<?php
/*
Plugin Name:FormSpammerTrap for Contact Form 7
Plugin URI: http://cellarweb.com/wordpress-plugins/
Description: Adds effective form spam bot blocking to Contact Form 7 forms via a simple shortcodes added to your Contact Form 7 form.
Stable tag: 1.01 
Version: 1.01
Tested up to: 4.8
Author: Rick Hellewell - CellarWeb.com
Author URI: http://CellarWeb.com
License: GPLv2 or later
License URI: http://www.gnu.org/licenses/gpl-2.0.html

*/

/*
Copyright (c) 2016-2017 by Rick Hellewell and CellarWeb.com
All Rights Reserved


This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License, version 2, as
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/
// ----------------------------------------------------------------
// ----------------------------------------------------------------
global $fst4cf7_version;
$fst4cf7_version = "1.01 (28-June-2017)";
global $atts;		// used for the shortcode parameters

// Add settings link on plugin page
function fst4cf7_settings_link($links) {
	$settings_link = '<a href="options-general.php?page=fst4cf7_settings" title="FormSpammerTrap for Contact Form 7 Info/Usage">Info/Usage</a>' ;
	array_unshift($links, $settings_link) ;
	return $links ;
}
$plugin = plugin_basename(__FILE__) ;
add_filter("plugin_action_links_$plugin", 'fst4cf7_settings_link') ;

//	build the class for all of this
class fst4cf7_Settings_Page {
	
// start your engines!
	public function __construct() {
		add_action( 'admin_menu', array($this, 'fst4cf7_add_plugin_page')) ;
	}
	
// add options page
	public function fst4cf7_add_plugin_page() {
// This page will be under "Settings"
		add_options_page( 'FormSpammerTrap for Contact Form 7 Info/Usage', 'FormSpammerTrap for Contact Form 7 Info/Usage', 'manage_options', 'fst4cf7_settings', array($this, 'fst4cf7_create_admin_page')) ;
	}
	
// options page callback
	public function fst4cf7_create_admin_page() {
	// Set class property
		$this->options = get_option('fst4cf7_options') ;
		echo '<div class="wrap">';
		fst4cf7_info_top() ;
		fst4cf7_info_bottom() ; 	// display bottom info stuff
		echo '</div>';
	}
	
// print the Section text
	public function fst4cf7_print_section_info() {
		print '<h3><strong>Information about FormSpammerTrap for Contact Form 7 from CellarWeb.com</strong></h3>' ;
	}
}
// end of the class stuff
if ( is_admin()) {
	$my_settings_page = new fst4cf7_Settings_Page() ;
	// ----------------------------------------------------------------------------
	// supporting functions
	// ----------------------------------------------------------------------------
	//	display the top info part of the page
	// ----------------------------------------------------------------------------
	function fst4cf7_info_top() {
		global $fst4cf7_version;
		?>

<div class="wrap" >
	<h2></h2>
	<!-- empty area for any WP status areas -->
	<hr />
	<div style="background-color:#9FE8FF;padding-left:15px;padding-bottom:10px;margin-bottom:15px;"> <br />
		<h1 align="center" style="font-size:300%"><strong>FormSpammerTrap for Contact Form 7</strong></h1>
		<h3 align="center">Very Effective SpamBot Blocking for Contact Form 7 Forms</h3>
		<p>Version <?php echo $fst4cf7_version; ?></p>
	</div>
	<hr />
	<div style="padding-left:15px;>"

	<p>With this add-in, one shortcode added to your Contact Form 7 form will effectively block form spam bots from spamming your Contact Form 7 forms. It does this with effective techniques, not things that don't work - like hidden fields, silly questions, or more. <em>If a bot tries to spam your form, they will get blocked. </em></p>
	<p>It is based on our very successful FormSpammerTrap for Comments plugin, which uses the same techniques to effectively block Comment Form Spammers. Check it out at <a href="https://wordpress.org/plugins/formspammertrap-for-comments/" target="_blank">https://wordpress.org/plugins/formspammertrap-for-comments/ </a>.</p>
	<p>More details about how it all works - and a Contact form that uses the same technique - is on our <a href="http://www.FormSpammerTrap.com" target="_blank">FormSpammerTrap</a> web site. There's a Contact form there that has <strong>never</strong> been successfully 'spam-botted' (defined as submitting many comments within a very short period of time). </p>
	<hr />
	<h3>Instructions</h3>
	<p>SpamBot blocking is done with a simple shortcode: just add <strong>[formspammertrap]</strong> anywhere on the Contact Form 7 form. (We usually put it at the top of the form, so it is always visible when editing the contact form.) </p>
	<p>Then make sure that at least one field on your contact form is required. You can tell if a field is required, because the field type (like 'text' or 'email') in the form will have an asterisk (so it will be 'text*' or 'email*').</p>
	<p>That's all there is to it! (Well, you do have to have Contact Form 7 installed, but activating our plugin will check to ensure that CF7 is alread installed and active.)</p>
	<p>Once you add the <strong>[formspammertrap]</strong> shortcode to the Contact form which has at least one required field, our advanced - and very effective - spambot blocking is active.</p>
	<hr />
	<h3>How It Works</h3>
	<p>We first change the form's 'action' value (where the form goes when submitted) to our FormSpammerTrap site. Then we look for required fields, and add events to check for a real person clicking or filling in that field. A real person will cause the form's action location to change back to the original value. A bot can't emulate a click or focus to an input field, so the action stays to our FormSpammerTrap.com site. </p>
	<p>The result is that a 'real person' will be able to successfully submit the form. But a spammer usually doesn't access your form like a 'real' visitor, so they will be immediately sent to the FormSpammerTrap.com site. Note that the required field checking of Contact Form 7 is not changed.</p>
	<hr />
	<h3>When It Doesn't Work</h3>
	<p>If you see <strong>[formspammertrap]</strong> when you view the contact form page, that probably means that the plugin got deactivated. Log in as an admin, and then use the Plugins page to activate the plugin.</li>
	<p>If you are still getting form spam, it may be that the plugin is not working. Here's how to check if it is working.</p>
	<ul style="list-style-type: disc; list-style-position: inside;padding-left:15px;"><li>First, check that your contact form has the <strong>[formspammertrap]</strong> code anywhere in the form. We like to put it up top so that it is visible when we edit the form, but you can place it anywhere.</li>
	<li>Make sure you have at least one form field that is required. The field name will have an asterisk, like 'text*' or 'email*'. This is required so that the form will get submitted and processed properly.</li>
	<li>After checking and saving the contact form, look at the page that contains the form. Make sure you have the right shortcode for the contact form.</li>
	<li>View the page, then right-click anywhere in the page (but not in the form), and select View Page Source. That will open up another tab with the source code of the page. There's a lot of stuff there, but we'll search for what we need.</li>
	<li>Press Ctrl+F (Find), then type in <strong>&lt;form</strong>. You should see the &lt;form&gt; tag; click the Highlight button to make it more visible.</li>
	<li>You should be able to see <strong>action</strong> near the &ltform tag. The action value should be "http://formspammertrap.com".</li>
	<li>Close that View Page Source tab. Then click once on a required field.</li>
	<li>Use the View Page Source, then Find the &lt;form tag again. You should see the Action value change to it's original value. That will verify that the plugin is working like it should.</li>
	<li>If you don't see the Action value change the second time you View Page Source, then it may be that your browser has disabled Javascript (although you should see a notice that Javascript needs to be enabled). Fix that, and all will be well. This problem is not likely, though, since WordPress (and other themes and plugins) has to have Javascript loaded for many of it's processes.</li></ul>
	<p>If you still have problems, let us know on the <a href="https://wordpress.org/support/plugin/formspammertrap-for-contact-form-7" title="Help or Questions" target="_blank">plugin support page.</a></p>

<hr />
<p><strong>Tell us how the FormSpammerTrap for Contact Form 7 plugin works for you - leave a <a href="https://wordpress.org/support/view/plugin-reviews/formspammertrap-for-contact-form-7" title="FormSpammerTrap for Contact Form 7 Reviews" target="_blank" >review or rating</a> on our plugin page.&nbsp;&nbsp;&nbsp;<a href="https://wordpress.org/support/plugin/formspammertrap-for-contact-form-7" title="Help or Questions" target="_blank">Get Help or Ask Questions here</a>.</strong></p>
</div>
<hr />
<div style="background-color:#9FE8FF;padding:3px 8px 3px 8px;">
	<p><strong>Interested in a plugin that will automatically add your Amazon Affiliate code to any Amazon links?&nbsp;&nbsp;&nbsp;Check out our nifty <a href="https://wordpress.org/plugins/amazolinkenator/" target="_blank">AmazoLinkenator</a>!&nbsp;&nbsp;It will probably increase your Amazon Affiliate revenue!</strong></p>
	<p>How about <strong><a href="https://wordpress.org/plugins/multisite-comment-display/" target="_blank">Multisite Comment Display</a></strong> to show all comments from all subsites? Or <strong><a href="https://wordpress.org/plugins/multisite-post-reader/" target="_blank">Multisite Post Reader</a></strong> to show all posts from all subsites? Or our <strong>U<a href="https://wordpress.org/plugins/url-smasher/" target="_blank">RL Smasher</a></strong> which automatically shortens URLs in pages/posts/comments? Just search for them in the Add Plugins screen - <strong>they are all free and fully featured!</strong></p>
</div>
<?php
	}
	
// ----------------------------------------------------------------------------
// display the copyright info part of the admin  page
// ----------------------------------------------------------------------------
function fst4cf7_info_bottom() {
// print copyright with current year, never needs updating
	$xstartyear = "2016" ;
	$xname = "Rick Hellewell" ;
	$xcompanylink1 = ' <a href="http://CellarWeb.com" title="CellarWeb" >CellarWeb.com</a>' ;
	echo '<hr><div style="background-color:#9FE8FF;padding-left:15px;padding:10px 0 10px 0;margin:15px 0 15px 0;">
	<p align="center">Copyright &copy; ' . $xstartyear . '  - ' . date("Y") . ' by ' . $xname . ' and ' . $xcompanylink1 ;
	echo ' , All Rights Reserved. Released under GPL2 license.</p></div><hr>' ;
	return ;
}
// end  copyright ---------------------------------------------------------

// ----------------------------------------------------------------------------
// ``end of admin area
//here's the closing bracket for the is_admin thing
}
// ----------------------------------------------------------------------------

// register/deregister/uninstall hooks

register_activation_hook( __FILE__, 'fst4cf7_register' );
register_deactivation_hook( __FILE__, 'fst4cf7_deregister' );
register_uninstall_hook(__FILE__, 'fst4cf7_uninstall');	

//  ----------------------------------------------------------------------------
// register/deregister/uninstall options (even though there aren't options)
function fst4cf7_register() {
	return;
}
//  ----------------------------------------------------------------------------
function fst4cf7_deregister() {
	return;
}

//  ----------------------------------------------------------------------------
function fst4cf7_uninstall() {
return;
}
//  ----------------------------------------------------------------------------
function fst4cf7_check_for_cf7() {
	require_once( ABSPATH . '/wp-admin/includes/plugin.php' );
	if (function_exists('wpcf7_add_form_tag')) {
		wpcf7_add_form_tag( 'formspammertrap', 'fst4cf7_process_shortcode', true );
	} else {
		//fst4cf7_show_admin_notice();
		add_action( 'admin_notices', 'fst4cf7_show_admin_notice' );
		deactivate_plugins( plugin_basename( __FILE__ ) ); 
		if ( isset( $_GET['activate'] ) ) {
			unset( $_GET['activate'] );
		}
	}
}
// display the admin notice if needed
function fst4cf7_show_admin_notice() { ?>
	<div class="error notice is-dismissible ">
		<p>Contact Form 7 plugin must be installed for the FormSpammerTrap for Contact Form 7 plugin to work. <a href="'.admin_url('plugin-install.php?tab=search&s=contact+form+7').'">Install Contact Form 7 here</a>. The FormSpammerTrap for Contact Form 7 plugin has been deactivated.</p>
		<p>After installing Contact Form 7, you should re-activate the FormSpammerTrap for Contact Form 7 plugin.</p>
	</div>
	<?php
}
//  ----------------------------------------------------------------------------
// set up shortcodes

function fst4cf7_shortcodes_init()
	{
		fst4cf7_check_for_cf7();	// check for cf7 installed and activated
		add_shortcode('formspammertrap', 'fst4cf7_process_shortcode');
	}
// Some form and other init stuff
$fst4cf7_formid = 'formspammertrap_' . fst4cf7_guidnodash();
add_action('init', 'fst4cf7_shortcodes_init');
// change the id value of the form
add_filter('wpcf7_form_id_attr', 'fst4cf7_form_id',10,1);

// ----------------------------------------------------------------------------
// here's where we do the work!
// ----------------------------------------------------------------------------

function fst4cf7_process_shortcode($atts = array()) {
	global $fst4cf7_formid;
	// check for attributes in the shortcode
	if (! empty($atts)) {
		$atts = array_map('sanitize_text_field', $atts);
		if (! isset($atts[attributename])) { $atts[attributename] = "";}
	}
	// modify the form
	fst4cf7_modify_field($fst4cf7_formid) ; // modify the required fields
	return;}

// ----------------------------------------------------------------------------
// look for and modify all required fields with the on_click and on_focus 
function fst4cf7_modify_field($fst4cf7_formid) {
	// get all of the elements from the $fst4cf7_formid object
	fst4cf7_action($fst4cf7_formid); 	// change the action value
	return;
}
// ----------------------------------------------------------------------------
// change the form id
function fst4cf7_form_id() {
	global $fst4cf7_formid;
	return $fst4cf7_formid;
}

// ----------------------------------------------------------------------------
// change the forms' action value
function fst4cf7_action($fst4cf7_formid) {
	?>
	<noscript>
	Javascript must be enabled for this form. 
	</noscript>
	<?php
	// all actions must be javascript, and need to wait for the document to be loaded!
	?>
	<script>
	document.addEventListener("DOMContentLoaded", function(event) { 	// wait for doc load to finish
	  //do work
		var saveaction = document.getElementById("<?php echo $fst4cf7_formid;?>").action;
		document.getElementById('<?php echo $fst4cf7_formid;?>').action = 'http://formspammertrap.com';
		var x = document.getElementById("<?php echo $fst4cf7_formid;?>"); // loop through form elements
		var txt = "";
		var i; 
		for (i = 0; i < x.length; i++) {
			var r = x.elements[i].hasAttribute("aria-required"); // check for required field
			if (r) {	// set onclick/onfocus atributes for required field
				x.elements[i].setAttribute("onclick", "fst4cf7_click('" + saveaction + "');");	
				x.elements[i].setAttribute("onfocus", "fst4cf7_click('" + saveaction + "');");	
			}
			txt = txt + x.elements[i].name + " type = " + x.elements[i].type + " required = " + r + "<br>";   
		}
	});
	// supporting functions
		function fst4cf7_click(saveaction) { // if required field clicked, put the original action back
			document.getElementById("<?php echo $fst4cf7_formid;?>").action = saveaction;
		}
	</script>
	<?php
	return;
}
// ----------------------------------------------------------------------------
// fst javascript function to insert (pending)
function fst4cf7_scripts() {
	?>
<script type="text/x-javascript">
// fst functions here
</script>
<?php
return;
}
// ----------------------------------------------------------------------------
// insert the fst_cl() on_click and on_focus tags
function fst4cf7_insert_field_click() {
	
	return;
}
//------------------------------------------------------------------------------
// GUID functions
//------------------------------------------------------------------------------
function fst4cf7_guid() {
return sprintf( '%04X%04X-%04X-%04X-%04X-%04X%04X%04X', mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(16384, 20479), mt_rand(32768, 49151), mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(0, 65535)) ;
}
// ----------------------------------------------------------------------------
function fst4cf7_guidnodash() {
$xguid = fst4cf7_guid() ;
//echo $xguid ."<br>";
return str_replace("-", "", $xguid) ;
}

// ----------------------------------------------------------------------------
// debugging function to show array values nicely formatted
function fst4cf7_show_array( $xarray = array()) {
	echo "<pre>"; print_r($xarray);echo "</pre>";
	return;
}
// ===============================================================================
//	end functions  
// ===============================================================================
// ----------------------------------------------------------------------------
// all done!
// ----------------------------------------------------------------------------


